using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AvaCorp.Virtual.Util;
using AvaCorp.Virtual.BLL;
using System.Collections.Generic;
using System.Text;
using System.Net.Mail;

namespace AvaCorp.Virtual.WS
{
    /// <summary>
    /// Summary description for CopiaEletronicaFatura
    /// </summary>
    public class CopiaEletronica
    {
        public CopiaEletronica()
        {
        }

        public Types.Retorno Fatura(int pGrupo, int pEmpresa, int pFilial, int pUnidade, int pSequencia, string pDestinatario, string pNickName)
        {
            Types.Retorno retorno = new Types.Retorno();
            Krypto krypto = new Krypto();
            bool bAchoEmail = false;
            
            bool UtilizarDadosdaFaturaNoAssuntodoEmail = Convert.ToBoolean(System.Configuration.ConfigurationManager.AppSettings["UtilizarDadosdaFaturaNoAssuntodoEmail"]);
            try
            {
                Auditoria.GravaMensagem(String.Format("Grupo: {0} - Empresa: {1} - Filial: {2} - Unidade: {3} - Sequencia: {4}", pGrupo, pEmpresa, pFilial, pUnidade, pSequencia));
                DALConnections.BeginTransaction();
                Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, 6);
                Unidade.Select(pGrupo, pEmpresa, pFilial, pUnidade, 7);
                string qsCTe = krypto.TextEncrypt(String.Format("{0}-{1}-{2}-{3}-{4}-CTe", pGrupo, pEmpresa, pFilial, pUnidade, pSequencia));
                string qsFatura = krypto.TextEncrypt(String.Format("{0}-{1}-{2}-{3}-{4}-Fatura", pGrupo, pEmpresa, pFilial, pUnidade, pSequencia));

                Fatura faturaBLL = new Fatura();
                faturaBLL.Update(pGrupo, pEmpresa, pFilial, pUnidade, pSequencia, qsCTe, qsFatura);
                Types.Fatura fatura = faturaBLL.Select(pGrupo, pEmpresa, pFilial, pUnidade, pSequencia);
                Cadastro cadastro = new Cadastro();
                Types.Cadastro cliente = cadastro.Select(fatura.Cliente);
                SmtpClient SmtpServer = AvaCorp.Virtual.Util.EmailHelper.ConfigurarClienteSmtp(Types.Unidade.HostSMTP, Types.Unidade.EmailName, Types.Unidade.EmailPassword);

                if (string.IsNullOrEmpty(pDestinatario))
                {
                    foreach (Types.Contato contato in new BLL.Contato().Select(fatura.Grupo, fatura.Empresa, fatura.Cliente, fatura.TipoContato, fatura.TipoContatoCategoria))
                    {
                        bAchoEmail = true;

                        Auditoria.GravaMensagem(String.Format("Nome: {0} - E-mail: {1}", contato.Nome, contato.Email));
                        Dictionary<string, string> valorParaSubstituir = new Dictionary<string, string>();
                        valorParaSubstituir["{Empresa}"] = Types.Empresa_Configuracao.Nome;
                        valorParaSubstituir["{Nickname}"] = contato.Nome;
                        valorParaSubstituir["{site}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsulta, fatura.QueryStringFatura);
                        valorParaSubstituir["{sitecte}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsultaCTe, fatura.QueryStringCTe);
                        valorParaSubstituir["{sitexml}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsultaXML, fatura.QueryStringCTe);
                        valorParaSubstituir["{EmailContato}"] = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                        valorParaSubstituir["{Numero}"] = fatura.Numero.ToString();
                        valorParaSubstituir["{Vencimento}"] = fatura.DtVencimento.ToString("dd/MM/yyyy");

                        #region Incluso no AvaMail
                        Types.LogEmailEnviado email = new Types.LogEmailEnviado();
                        email.Grupo = fatura.Grupo;
                        email.Empresa = fatura.Empresa;
                        email.Cnpjcpfcodigo = String.Empty;
                        email.EmailDestinatario = contato.Email;
                        email.DataInclusao = DateTime.Now;
                        email.EmailRetorno = Configuracoes.EmailRetorno;
                        email.Prioridade = 2;
                        email.Texto = EmailHelper.FormataCorpo(Serializacao.MailHtmlFileFatura, Serializacao.MailImagePath, valorParaSubstituir);
                        if (!UtilizarDadosdaFaturaNoAssuntodoEmail)
                        { 
                            email.Titulo = EmailHelper.FormataTitulo(Serializacao.MailHtmlFileFatura, valorParaSubstituir);
                            //email.Titulo = String.Format("A/C {0}", contato.Nome);
                        }
                        else
                        { 
                            email.Titulo = String.Format("Faturamento {0} - Fatura {1}", cliente.RazaoSocial, fatura.Numero.ToString());
                        }

                        email.UsuarioInclusao = 1;
                        email.Filial = fatura.Filial;
                        email.Unidade = fatura.Unidade;
                        email.NumeroSequencia = fatura.Sequencia;
                        email.TipoDocumento = 7;

                        // Verifica se deve eviar a empresa como CC ou BCC
                        if (Convert.ToBoolean(ConfigurationManager.AppSettings["FaturaEletronicaUsarBCC"]))
                        {
                            email.EmailsCopiaOculta = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                        }
                        else
                        {
                            email.EmailsCopia = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                        }

                        LogEmailEnviado logEmail = new LogEmailEnviado();
                        logEmail.Insert(email);
                        if (!String.IsNullOrEmpty(Configuracoes.EmailCopia))
                        {
                            email.EmailDestinatario = Configuracoes.EmailCopia;
                            logEmail.Insert(email);
                        }
                        #endregion
                    }
                }
                else
                {
                    Auditoria.GravaMensagem(String.Format("Nome: {0} - E-mail: {1}", pNickName, pDestinatario));
                    Dictionary<string, string> valorParaSubstituir = new Dictionary<string, string>();
                    valorParaSubstituir["{Empresa}"] = Types.Empresa_Configuracao.Nome;
                    valorParaSubstituir["{Nickname}"] = pNickName;
                    valorParaSubstituir["{site}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsulta, fatura.QueryStringFatura);
                    valorParaSubstituir["{sitecte}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsultaCTe, fatura.QueryStringCTe);
                    valorParaSubstituir["{sitexml}"] = String.Format("{0}?q={1}", Configuracoes.WebSiteConsultaXML, fatura.QueryStringCTe);
                    valorParaSubstituir["{EmailContato}"] = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                    valorParaSubstituir["{Numero}"] = fatura.Numero.ToString();
                    valorParaSubstituir["{Vencimento}"] = fatura.DtVencimento.ToString("dd/MM/yyyy");


                    #region Incluso no AvaMail
                    Types.LogEmailEnviado email = new Types.LogEmailEnviado();
                    email.Grupo = fatura.Grupo;
                    email.Empresa = fatura.Empresa;
                    email.Cnpjcpfcodigo = String.Empty;
                    email.EmailDestinatario = pDestinatario;
                    email.DataInclusao = DateTime.Now;
                    email.EmailRetorno = Configuracoes.EmailRetorno;
                    email.Prioridade = 2;
                    email.Texto = EmailHelper.FormataCorpo(Serializacao.MailHtmlFileFatura, Serializacao.MailImagePath, valorParaSubstituir);
                    if (!UtilizarDadosdaFaturaNoAssuntodoEmail)
                    {
                        email.Titulo = EmailHelper.FormataTitulo(Serializacao.MailHtmlFileFatura, valorParaSubstituir);
                        //email.Titulo = String.Format("A/C {0}", contato.Nome);
                    }
                    else
                    {
                        email.Titulo = String.Format("Faturamento {0} - Fatura {1}", cliente.RazaoSocial, fatura.Numero.ToString());
                    }
                    email.UsuarioInclusao = 1;
                    email.Filial = fatura.Filial;
                    email.Unidade = fatura.Unidade;
                    email.NumeroSequencia = fatura.Sequencia;
                    email.TipoDocumento = 7;

                    // Verifica se deve eviar a empresa como CC ou BCC
                    if (Convert.ToBoolean(ConfigurationManager.AppSettings["FaturaEletronicaUsarBCC"]))
                    {
                        email.EmailsCopiaOculta = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                    }
                    else
                    {
                        email.EmailsCopia = AvaCorp.Virtual.Types.Unidade.EmailEmpresa;
                    }

                    LogEmailEnviado logEmail = new LogEmailEnviado();
                    logEmail.Insert(email);
                    if (!String.IsNullOrEmpty(Configuracoes.EmailCopia))
                    {
                        email.EmailDestinatario = Configuracoes.EmailCopia;
                        logEmail.Insert(email);
                    }
                    #endregion
                }

                retorno.CodigoRetorno = true;

                if (string.IsNullOrEmpty(pDestinatario))
                {
                    if (bAchoEmail)
                        retorno.DescricaoRetorno = "Email enviado com sucesso";
                    else
                        retorno.DescricaoRetorno = string.Format("No foram encontrados contatos marcados como responsvel e configurados para enviar e-mail para o tipo de contato {0}, categoria {1} para o cliente {2}.", fatura.TipoContato, fatura.TipoContatoCategoria, fatura.Cliente);

                }
                else
                {
                    retorno.DescricaoRetorno = "Email enviado com sucesso";
                }

                Auditoria.GravaMensagem(String.Format("Fatura numero: {0} - {1}", fatura.Numero, retorno.DescricaoRetorno));
                DALConnections.CommitTransaction();
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
                DALConnections.RollbackTransaction();
                retorno.DescricaoRetorno = String.Format("{0}{1}", ex.Message, ex.InnerException);
                LogSource.Log.GravarMensagem(7, ex, 1, "Copia eletronica fatura", DALConnections.ConnectionString, retorno.DescricaoRetorno);
            }
            return retorno;
        }
    }
}