using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AvaCorp.Virtual.BLL;
using AvaCorp.Virtual.Util;
using System.Xml;
using System.Collections;
using System.IO;
using AvaCorp.Virtual.Services.CTe.Recepcao;
using AvaCorp.Virtual.Services.NFe.Recepcao;
using AvaCorp.Virtual.BLL.CTe.XML;
using AvaCorp.Virtual.BLL.NFe.XML;
using System.Text.RegularExpressions;

namespace AvaCorp.Virtual.WS
{
    /// <summary>
    /// Summary description for Enviar
    /// </summary> 
    public class Enviar
    {
        public Enviar()
        {
            FillHashTipoDocumento();
        }

        private Hashtable tipoDocumentoHash = new Hashtable();

        /// <summary>
        /// Carrega string dos dados
        /// </summary>
        private void FillHashTipoDocumento()
        {
            tipoDocumentoHash.Add(6, @"CTe\Rodo\");
            tipoDocumentoHash.Add(12, @"NFe\");
            tipoDocumentoHash.Add(97, @"CTe\Aereo\");
        }

        public AvaCorp.Virtual.Types.Retorno DocumentoEletronico(string pChaveAcessoWebService, int pTipoDocumento, int pGrupo, int pEmpresa, int pFilial, int pUnidade, int pCodigoUsuario, Int64 pNumeroLote)
        {
            bool erro = false;
            AvaCorp.Virtual.Types.Retorno retorno = new AvaCorp.Virtual.Types.Retorno();
            try
            {
                #region Carrega parmetros
                //DALConnections.BeginTransaction();

                //Auditoria.GravaMensagem(String.Format("Enviar\tChaveAcesso:{0}\tTipoDocumento:{1}\tGrupo:{2}\tEmpresa:{3}\tFilial:{4}\tUnidade:{5}\tCodigoUsuario:{6}\tNumeroLote:{7}", pChaveAcessoWebService, pTipoDocumento, pGrupo, pEmpresa, pFilial, pUnidade, pCodigoUsuario, pNumeroLote));
                //Configuracoes.GetParametros(pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento);
                int servicoDocumentoEletronico = pTipoDocumento == 12 ? 20 : 2;
                
                #region Envio de Lote no EDIWS
                #region CTe v2.00/v3.00
                if (pTipoDocumento == 6)
                {
                    try
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        //DALConnections.RollbackTransaction();

                        var recepcaoCTe = new RecepcaoCTe();
                        return recepcaoCTe.EnviarEDIWS(pChaveAcessoWebService, pGrupo, pEmpresa, pFilial, pTipoDocumento, pNumeroLote, pCodigoUsuario);
                    }
                    catch (Exception ex)
                    {
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = String.Format("Problemas ao enviar documento pelo EDIWS : {0}", ex.Message);
                        return retorno;
                    }
                }
                #endregion
                #region NFe v3.10/v4.00
                if (pTipoDocumento == 12)
                {
                    try
                    {
                        // Se vai fazer a transmisso pelo EDIWS, aborta a transao, pois ela no  mais necessria
                        //DALConnections.RollbackTransaction();

                        var recepcaoNFe = new RecepcaoNFe();
                        return recepcaoNFe.EnviarEDIWS(pChaveAcessoWebService, pGrupo, pEmpresa, pFilial, pTipoDocumento, pNumeroLote, pCodigoUsuario);
                    }
                    catch (Exception ex)
                    {
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = String.Format("Problemas ao enviar documento pelo EDIWS : {0}", ex.Message);
                        return retorno;
                    }
                }
                #endregion
                #endregion

                Serializacao serializacao = new Serializacao();
                DocumentoEletronicoLote documentoEletronicoLote = new DocumentoEletronicoLote();
                BLL.Estado_ParametroDocumentoEletronico estadoBLL = new Estado_ParametroDocumentoEletronico();
                Types.Estado_ParametroDocumentoEletronico estadoParametroDocumentoEletronico = estadoBLL.Select("BRA", AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, servicoDocumentoEletronico);

                XmlNode xmlEnvio = null;
                XmlNode xmlRetornoEnvio = null;

                string pathReturn = String.Format(@"{0}Grupo-{1}\Empresa-{2}\{3}{4}", Serializacao.CaminhoRetorno, pGrupo, pEmpresa, tipoDocumentoHash[pTipoDocumento], Types.Unidade_Parametro.CodigoIBGEEstado);
                string arquivoRetorno = String.Format(@"{0}\{1}-rec.xml", pathReturn, pNumeroLote.ToString().PadLeft(9, '0'));
                #endregion
                #region Gera Lote XML
                bool arquivoEncontrado = VerificaArquivoLoteEnviado(pGrupo, pEmpresa, pTipoDocumento, pNumeroLote, arquivoRetorno);
                if (!arquivoEncontrado)
                {
                    try
                    {
                        xmlEnvio = serializacao.ExportaDocumento(pChaveAcessoWebService, pGrupo, pEmpresa, pFilial, pUnidade, pTipoDocumento, pNumeroLote, false, estadoParametroDocumentoEletronico, pCodigoUsuario);
                        #region Enviar documento para SEFAZ
                        if (xmlEnvio != null)
                        {
                            switch (pTipoDocumento)
                            {
                                case 6:
                                case 97:
                                    #region Enviar CT-e
                                    RecepcaoCTe recepcao = new RecepcaoCTe();
                                    TRetEnviCTe retEnviCTe = recepcao.WSEnviaLoteCTe(xmlEnvio, pNumeroLote, pTipoDocumento, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                                    #endregion
                                    #region Verfica retorno da SEFAZ
                                    if (!ServicoParalisado(retEnviCTe.cStat))
                                    {

                                        #region Verifica se possui recibo
                                        Auditoria.GravaMensagem(String.Format("Status:{0}-{1}", retEnviCTe.cStat, retEnviCTe.xMotivo));
                                        if (retEnviCTe.infRec == null)
                                            retorno.CodigoRetorno = false;
                                        else
                                        {
                                            retorno.CodigoRetorno = true;
                                            Auditoria.GravaMensagem(String.Format("Recibo:{0}", retEnviCTe.infRec.nRec));
                                        }
                                        #endregion
                                        #region Grava retorno
                                        retorno.DescricaoRetorno = retEnviCTe.xMotivo;
                                        xmlRetornoEnvio = serializacao.GetMemoryXML(typeof(TRetEnviCTe), retEnviCTe);
                                        documentoEletronicoLote.Update(retEnviCTe, pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote);
                                        #endregion

                                        // Realiza a inutilizao do documento se constatar um status de rejeio.
                                        // OBS.: Quando o status  de rejeio, o cancelamento do documento  realizado via Trigger
                                        if (DocumentoRejeitado(pTipoDocumento, retEnviCTe.cStat))
                                            InutilizaDocumento(pGrupo, pEmpresa, pFilial, pUnidade, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, retEnviCTe.xMotivo);

                                    }
                                    else
                                    {
                                        retorno.CodigoRetorno = false;
                                        retorno.DescricaoRetorno = retEnviCTe.xMotivo;
                                        DALConnections.RollbackTransaction();
                                        ExcluirXmlEnvioRetornoEnvio(pGrupo, pEmpresa, pTipoDocumento, pNumeroLote, arquivoRetorno);
                                    }
                                    #endregion
                                    break;
                                case 12:
                                    #region Enviar NF-e
                                    RecepcaoNFe recepcaoNFe = new RecepcaoNFe();
                                    TRetEnviNFe retEnviNFe = recepcaoNFe.WSEnviaLoteNFe(xmlEnvio, pNumeroLote, pTipoDocumento, estadoParametroDocumentoEletronico, pGrupo, pEmpresa);
                                    #endregion
                                    #region Verfica retorno da SEFAZ
                                    if (!ServicoParalisado(retEnviNFe.cStat))
                                    {
                                        #region Verifica se possui recibo
                                        Auditoria.GravaMensagem(String.Format("Status:{0}-{1}", retEnviNFe.cStat, retEnviNFe.xMotivo));
                                        if (retEnviNFe.infRec != null)
                                            retorno.CodigoRetorno = false;
                                        else
                                        {
                                            retorno.CodigoRetorno = true;
                                            Auditoria.GravaMensagem(String.Format("Recibo:{0}", retEnviNFe.infRec.nRec));
                                        }
                                        #endregion
                                        #region Grava retorno
                                        retorno.DescricaoRetorno = retEnviNFe.xMotivo;
                                        xmlRetornoEnvio = serializacao.GetMemoryXML(typeof(TRetEnviNFe), retEnviNFe);
                                        documentoEletronicoLote.Update(retEnviNFe, pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote);
                                        #endregion

                                        // Realiza a inutilizao do documento se constatar um status de rejeio.
                                        // OBS.: Quando o status  de rejeio, o cancelamento do documento  realizado via Trigger
                                        if (DocumentoRejeitado(pTipoDocumento, retEnviNFe.cStat))
                                            InutilizaDocumento(pGrupo, pEmpresa, pFilial, pUnidade, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, retEnviNFe.xMotivo);
                                    }
                                    else
                                    {
                                        retorno.CodigoRetorno = false;
                                        retorno.DescricaoRetorno = retEnviNFe.xMotivo;
                                        DALConnections.RollbackTransaction();
                                        ExcluirXmlEnvioRetornoEnvio(pGrupo, pEmpresa, pTipoDocumento, pNumeroLote, arquivoRetorno);
                                    }
                                    #endregion
                                    break;
                                default: throw new Exception(String.Format("Documento selecionado \"{0}\" no implementado", pTipoDocumento));
                            }
                            DALConnections.CommitTransaction();
                        }
                        else
                        {
                            DALConnections.CommitTransaction();
                            InutilizaDocumento(pGrupo, pEmpresa, pFilial, pUnidade, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, "Falha no Schema do documento eletrnico");
                            retorno.CodigoRetorno = false;
                            retorno.DescricaoRetorno = "Erro no documento eletrnico";
                        }
                        #endregion
                    }
                    catch (XmlException ex)
                    {
                        erro = true;
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = ex.Message;
                        Auditoria.GravaMensagem(ex.Message);
                        DALConnections.CommitTransaction();
                        InutilizaDocumento(pGrupo, pEmpresa, pFilial, pUnidade, Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, ex.Message);
                    }
                    catch (Exception ex)
                    {
                        erro = true;
                        retorno.CodigoRetorno = false;
                        retorno.DescricaoRetorno = ex.Message;
                        Auditoria.GravaMensagem(retorno.DescricaoRetorno);
                        DALConnections.RollbackTransaction();
                    }
                }
                #endregion
                # region Gravao do XML para Arquivo Digital
                if (arquivoEncontrado && !erro && xmlEnvio == null)
                {
                    retorno.CodigoRetorno = true;
                    retorno.DescricaoRetorno = "Documento enviado com sucesso";
                }
                if ((!arquivoEncontrado && !erro) && (xmlEnvio != null))
                {
                    GravaXmlDocumentoEletronicoLoteEnvio(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote,
                        xmlEnvio.OuterXml.Normalize(), xmlRetornoEnvio.OuterXml.Normalize(), arquivoRetorno);
                }
                #endregion

                #region Atualiza a tabela logSistema
                System.Diagnostics.StackFrame stack = new System.Diagnostics.StackFrame(2);
                string rotina = stack.GetMethod().ToString();
                int usuario = 1;
                string mensagem;
                string contexto;

                #region Atualiza a tabela logSistema apos consulta

                contexto = "Enviar Documento eletrnico";
                mensagem = string.Format("Lote: {0}", pNumeroLote);
                AvaCorp.Virtual.BLL.LogSistema.LogUtilizacaoServicos(usuario, rotina, mensagem, contexto);
                #endregion
                #endregion

            }
            catch (InvalidOperationException ex)
            {
                retorno.CodigoRetorno = false;
                retorno.DescricaoRetorno = String.Format("Problemas ao enviar {0} {1}", ex.Message, ex.StackTrace);
                Auditoria.GravaMensagem(retorno.DescricaoRetorno);
                DALConnections.RollbackTransaction();
                LogSource.Log.GravarMensagem(pTipoDocumento, ex, pCodigoUsuario, "Enviar", DALConnections.ConnectionString, retorno.DescricaoRetorno);
            }
            catch (Exception ex)
            {
                retorno.CodigoRetorno = false;
                retorno.DescricaoRetorno = String.Format("Problemas ao enviar {0} {1}", ex.Message, ex.StackTrace);
                Auditoria.GravaMensagem(String.Format("Problemas ao enviar {0} {1}", ex.Message, ex.StackTrace));
                DALConnections.RollbackTransaction();
            }
            return retorno;
        }

        private void InutilizaDocumento(int grupo, int empresa, int filial, int unidade, string uf, int tipoDocumento, Int64 numeroLote, string justificativa)
        {
            DocumentoEletronicoLote lote = new DocumentoEletronicoLote(DALConnections.ConnectionString);
            if (!lote.LoteEmissaoContingencia(grupo, empresa, uf, tipoDocumento, numeroLote))
            {   //Somente podera ser inutilizado a numerao quando o documento no for emitido em contingncia.
                using (AvaCorpVirtual ws = new AvaCorpVirtual())
                {
                    Types.DocumentoEletronicoInutilizacao inutilizar = new BLL.DocumentoEletronicoInutilizacao().SelectDocumentosPeloLote(grupo, empresa, uf, tipoDocumento, numeroLote);
                    ws.InutilizarDocumentoEletronico(Types.Empresa_Configuracao.ChaveAcessoWebServiceDocumentoEletronico, tipoDocumento, grupo, empresa, filial, unidade, Convert.ToString(inutilizar.SerieDocumento), inutilizar.NumeroInicial, inutilizar.NumeroFinal, AnoParaInutilizar(inutilizar.DtEmissaoDocumento), inutilizar.Usuario, justificativa);
                }
            }
        }

        /// <summary>
        ///Essa gambi  foi feita porque as vezes o usurio coloca a data de emisso do documento superior ou inferior a atual
        ///Ex.: Ano = 1966, como o sistema pega apenas os dois ltimos nmero para enviar a SEFAZ para inutilizar acontece erro
        /// </summary>
        /// <param name="emissao"></param>
        /// <returns></returns>
        private string AnoParaInutilizar(DateTime emissao)
        {
            return int.Parse(emissao.ToString("yy")) > int.Parse(DateTime.Today.ToString("yy")) ? DateTime.Today.ToString("yy") : emissao.ToString("yy");
        }

        /// <summary>
        /// Estando paralisado o servidor ser postergado o envio
        /// <para>108 - Servio Paralisado Momentaneamente (curto prazo)</para>
        /// <para>109 - Servio Paralisado sem Previso</para>
        /// </summary>
        /// <param name="pCodigoStatus"></param>
        /// <returns></returns>
        private bool ServicoParalisado(string pCodigoStatus)
        {
            return ((pCodigoStatus == "108") || (pCodigoStatus == "109"));
        }
        /// <summary>
        /// Erro genrico da SEFAZ
        /// <para>999 - Erro no catalogado</para>
        /// </summary>
        /// <param name="pCodigoStatus"></param>
        /// <returns></returns>
        public static bool ErroNaoCatalogado(string pCodigoStatus)
        {
            return pCodigoStatus == "999";
        }

        /// <summary>
        /// Verifica se o status  de documento cancelado no SEFAZ
        /// </summary>
        /// <param name="pCodigoStatus"><para>218 - Rejeio: CT-e j est cancelada na base de dados da SEFAZ</para></param>
        /// <returns></returns>
        private bool DocumentoCanceladoSEFAZ(string pCodigoStatus)
        {
            return (pCodigoStatus == "218");
        }

        /// <summary>
        /// Verifica se o status  de Rejeio de Lote
        /// </summary>
        /// <param name="pTipoDocumento">Cdigo do Tipo de Documento</param>
        /// <param name="pCodigoStatus">Cdigo do Status de Envio ou Resposta do SEFAZ</param>
        /// <returns></returns>
        private bool DocumentoRejeitado(int pTipoDocumento, string pCodigoStatus)
        {
            var docRetorno = new BLL.DocumentoEletronicoRetorno().SelectTipo(pTipoDocumento, int.Parse(pCodigoStatus));

            return docRetorno.Tipo == 4;
        }

        /// <summary>
        /// Mtodo que ir verificar se o arquivo de retorno da SEFAZ est no diretrio da aplicao, pois houve 
        /// perda de conexo com o banco durante o retorno do envio.
        /// </summary>
        /// <param name="pGrupo">int</param>
        /// <param name="pEmpresa">int</param>
        /// <param name="pTipoDocumento">int</param>
        /// <param name="pNumeroLote">int64</param>
        /// <param name="arquivoRetorno">string</param>
        /// 
        /// C:\inetpub\wwwroot\AvaCorpVirtual\WS\Xml\Retorno\Grupo-1\Empresa-1\CTe\Rodo\43
        /// <returns></returns>
        private bool VerificaArquivoLoteEnviado(int pGrupo, int pEmpresa, int pTipoDocumento, Int64 pNumeroLote, string arquivoRetorno)
        {
            if (File.Exists(arquivoRetorno))
            {
                Auditoria.GravaMensagem(String.Format("Encontrado arquivo: {0}", arquivoRetorno));

                DocumentoEletronicoLote documentoEletronicoLote = new DocumentoEletronicoLote();
                XmlDocument xmlDocumentoProcessamento = new XmlDocument();
                RecepcaoCTe recepcaoCTe = new RecepcaoCTe();
                RecepcaoNFe recepcaoNFe = new RecepcaoNFe();

                xmlDocumentoProcessamento.Load(arquivoRetorno);
                XmlNode xmlRetornoProcessamento = xmlDocumentoProcessamento;

                string status = Regex.Match(xmlRetornoProcessamento.OuterXml, @"<cStat>(?<status>.*)</cStat>", RegexOptions.Singleline | RegexOptions.IgnoreCase).Groups["status"].Value;

                if (ServicoParalisado(status) || ErroNaoCatalogado(status))
                {
                    Auditoria.GravaMensagem("Deletando o arquivo encontrado.");
                    File.Delete(arquivoRetorno);
                    return false;
                }
                else
                {
                    XmlDocument xmlEnvio = new XmlDocument();
                    string pathExport = String.Format(@"{0}\Grupo-{1}\Empresa-{2}\{3}{4}", Serializacao.CaminhoExportacao, pGrupo, pEmpresa, tipoDocumentoHash[pTipoDocumento], Types.Unidade_Parametro.CodigoIBGEEstado);
                    xmlEnvio.Load(String.Format(@"{0}\{1}-env-lot.xml", pathExport, pNumeroLote.ToString().PadLeft(9, '0')));
                    switch (pTipoDocumento)
                    {
                        case 6:
                        case 97:
                            TRetEnviCTe retEnviCTe = recepcaoCTe.RetornaEnvioCTe(xmlRetornoProcessamento, pNumeroLote);
                            documentoEletronicoLote.Update(retEnviCTe, pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote);
                            GravaXmlDocumentoEletronicoLoteEnvio(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, xmlEnvio.OuterXml, xmlRetornoProcessamento.OuterXml, arquivoRetorno);
                            break;
                        case 12:
                            TRetEnviNFe retEnviNFe = recepcaoNFe.RetornaEnvioNFe(xmlRetornoProcessamento.OuterXml);
                            documentoEletronicoLote.Update(retEnviNFe, pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote);
                            GravaXmlDocumentoEletronicoLoteEnvio(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, xmlEnvio.OuterXml, xmlRetornoProcessamento.OuterXml, arquivoRetorno);
                            break;
                        default:
                            throw new Exception("Documento no implementado");
                    }
                }
                DALConnections.CommitTransaction();
                return true;
            }
            return false;
        }

        /// <summary>
        /// Grava o XML de Envio e Retorno de envio no banco de dados, aps gravar ser excludo do sistema de arquivo os XMLs.
        /// </summary>
        /// <param name="pGrupo"></param>
        /// <param name="pEmpresa"></param>
        /// <param name="pUF"></param>
        /// <param name="pTipoDocumento"></param>
        /// <param name="pNumeroLote"></param>
        /// <param name="pXmlEnvio"></param>
        /// <param name="pXmlRetornoEnvio"></param>
        /// <param name="arquivoRetorno"></param>
        private void GravaXmlDocumentoEletronicoLoteEnvio(int pGrupo, int pEmpresa, string pUF, int pTipoDocumento, Int64 pNumeroLote, string pXmlEnvio, string pXmlRetornoEnvio, string arquivoRetorno)
        {
            try
            {
                XmlDocumentoEletronicoLote xmlDocumentoEletronicoLote = new XmlDocumentoEletronicoLote(pGrupo, pEmpresa, AvaCorp.Virtual.Types.Unidade_Parametro.UFEmissor, pTipoDocumento, pNumeroLote, pXmlEnvio, pXmlRetornoEnvio, String.Empty);
                if (!xmlDocumentoEletronicoLote.PossuiXML(pGrupo, pEmpresa, pUF, pTipoDocumento, pNumeroLote, false))
                    xmlDocumentoEletronicoLote.InsertWS();
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem("Problemas ao gravar o arquivo XML na tabela XmlDocumentoEletronicoLote " + ex.Message);
                throw new Exception(ex.Message);
            }
            ExcluirXmlEnvioRetornoEnvio(pGrupo, pEmpresa, pTipoDocumento, pNumeroLote, arquivoRetorno);
        }

        /// <summary>
        /// Exclui do sistema de arquivos o XML de Envio e Retorno de Envio
        /// </summary>
        /// <param name="pTipoDocumento"></param>
        /// <param name="pNumeroLote"></param>
        /// <param name="arquivoRetorno"></param>
        private void ExcluirXmlEnvioRetornoEnvio(int pGrupo, int pEmpresa, int pTipoDocumento, Int64 pNumeroLote, string arquivoRetorno)
        {
            try
            {
                if (Configuracoes.ExcluirXmlEnvio)
                {
                    string pathExport = String.Format(@"{0}\Grupo-{1}\Empresa-{2}\{3}{4}", Serializacao.CaminhoExportacao, pGrupo, pEmpresa, tipoDocumentoHash[pTipoDocumento], Types.Unidade_Parametro.CodigoIBGEEstado);
                    string arquivoEnvio = String.Format(@"{0}\{1}-env-lot.xml", pathExport, pNumeroLote.ToString().PadLeft(9, '0'));
                    Auditoria.GravaMensagem(String.Format("Excluindo arquivo de envio: {0}", arquivoEnvio));
                    File.Delete(arquivoEnvio);
                }
                if (Configuracoes.ExcluirXmlRetornoEnvio)
                {
                    Auditoria.GravaMensagem(String.Format("Excluindo arquivo de retorno: {0}", arquivoRetorno));
                    File.Delete(arquivoRetorno);
                }
            }
            catch (Exception ex)
            {
                Auditoria.GravaMensagem(ex.Message);
            }
        }
    }
}